//<c>   Copyright 1998-1999 by Gerry J. Danen; all rights reserved.

//<t>   Reverse the fields in a GETLINKS/MAKLINKS database
//      for finding dups

#include"gd_tools.h"
#include"gd_extrn.h"


#define pgVERS_ "V1.00"
#define pgTITL_ "Reverse Fields in GETLINKS/MAKLINKS database"
#define pgCOPR_ "1998"


long    lines = 0, linesIn = 0 ;
FILE    *iFh, *oFh ;
UCHAR   iFile[FS_LEN], oFile[FS_LEN], work[10001], sURL[1025], sTitle[1025],
        sHTMpart1[FS_LEN], sHTMpart2[FS_LEN], cMarker='\x03', sMarker[]="\x03" ;


void    ShowHelp( void )
{
    logon(1);
    printf( "\nUsage:  %s database_in database_out\n\n",
            get_global_program_name() );
    exit( 1 );
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
        ShowHelp();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        ShowHelp();
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    while ( fgets( work, (sizeof(work)-1), iFh ) )
    {
        linesIn ++ ;
        st_trim( work );
        if ( work[0] == cMarker )
            work[0] = EOS ;
        if ( strlen(work) )
        {
//          sURL[0] = EOS ;
            SplitString( work, sMarker, sTitle, sURL );  // title & URL split
            st_trim( sTitle );
            st_trim( sURL );
//printf( "[%s] [%s]\n", sURL, sTitle );
            if ( strlen(sTitle) && strlen(sURL) )
            {
                fprintf( oFh, "%s%s%s\n", sURL, sMarker, sTitle );
                lines ++ ;
            }
        }

    }
    fcloseall();

    printf( "%ld records read from %s;\n%ld records written to %s\n\n",
            linesIn, iFile, lines, oFile );

    exit( 0 );
}
