//<c>   Copyright 1998-1999 by Gerry J. Danen; all rights reserved.

//<t>   Extract links from an HTML file

#include"gd_tools.h"
#include"gd_extrn.h"


#define pgVERS_ "V1.00"
#define pgTITL_ "Extract links from an HTML file"
#define pgCOPR_ "1998"


long    lines = 0 ;
FILE    *iFh, *oFh ;
UCHAR   iFile[FS_LEN], oFile[FS_LEN], tFile1[]="$T01", tFile2[]="$T02",
        work[10001], work1[10001], sURL[1025], sTitle[1025],
        cMarker='\x03', sMarker[]="\x03" ;
BOOL    inRef = FALSE ;


void    ShowHelp( void )
{
    logon(1);
    printf( "\n\nUsage:  %s file_in file_out\n\n", get_global_program_name() );
    exit( 1 );
}


void    main( int argc, char *argv[] )
{
    int ch ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
        ShowHelp();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        ShowHelp();
    }

    if ( ( oFh = fopen( tFile1, "w" ) ) == NULL )
    {
        fprintf( stderr, "\n\nCannot create temp file %s\a\n", tFile1 );
        ShowHelp();
    }

    for (;;)
    {
        ch = fgetc( iFh );
        if ( feof(iFh) )
        {
            _fcloseall();
            break ;
        }
        if ( ch == '<' )                // <
        {
            fputc( '\n', oFh );         // write CR/LF
        }
        fputc( ch, oFh );
        if ( ch == '>' )                // >
        {
            fputc( '\n', oFh );         // write CR/LF
        }
    }

    if ( ( iFh = fopen( tFile1, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", tFile1 );
        ShowHelp();
    }

    if ( ( oFh = fopen( tFile2, "w" ) ) == NULL )
    {
        fprintf( stderr, "\n\nCannot create temp file %s\a\n", tFile1 );
        ShowHelp();
    }

    while ( fgets( work, (sizeof(work)-1), iFh ) )
    {
        st_trim( work );
        strcpy( work1, work );
        st_remove_spaces( work1 );
        if ( work1[8] == '#' )                  // don't want references on same page
        {
            work1[8] = EOS ;
            if ( st_eq(work1, "<AHREF=\"") )
                work[0] = work1[0] = EOS ;
        }
        work1[8] = EOS ;
        if ( st_eq(work1, "<AHREF=\"") )
        {
            sprintf( sURL, "%s", work );
            inRef = TRUE ;
            work[0] = work1[0] = EOS ;
        }
        if ( inRef )
        {
            if ( st_eq(work1, "</A>") )
            {
                fprintf( oFh, "%c%s\n", cMarker, sURL );
                inRef = FALSE ;
                work[0] = work1[0] = EOS ;
            }
            if ( work[0] == '<' )
                work[0] = work1[0] = EOS ;
            if ( strlen(work) )
            {
                fprintf( oFh, "%s ", work );
            }
        }
    }
    fcloseall();

    fl_delete( tFile1 );
    sprintf( work, "sorttext %s %s >nul", tFile2, tFile1 );
    system( work );


    if ( ( iFh = fopen( tFile1, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", tFile1 );
        ShowHelp();
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    while ( fgets( work, (sizeof(work)-1), iFh ) )
    {
        st_trim( work );
        if ( work[0] == cMarker )
            work[0] = EOS ;
        if ( strlen(work) )
        {
            sURL[0] = EOS ;
            SplitString( work, sMarker, sTitle, work1 );  // title
            st_trim( sTitle );
            st_trim( work1 );
            ch = st_ch_index( '\"', work1 );
            if ( ch > (-1) )
                strcpy( work, &work1[ch+1] );
            else
                strcpy( work, "" );
            ch = st_ch_index( '\"', work );
            if ( ch > (-1) )
                work[ch] = EOS ;
            strcpy( sURL, work );
            st_trim( sURL );
            if ( strlen(sTitle) && strlen(sURL) )
            {
                fprintf( oFh, "%s%s%s\n", sTitle, sMarker, sURL );
                lines ++ ;
            }
        }

    }
    fcloseall();

    printf( "Written %ld links to %s\n", lines, oFile );

    fl_delete( tFile1 );
    fl_delete( tFile2 );

    exit( 0 );
}
