//<c>   Copyright 1998-1999 by Gerry J. Danen; all rights reserved.

//<t>   Make an HTML file with data from GETLINKS
//      The input file is the output from GETLINKS, but cleaned up...

#include"gd_tools.h"
#include"gd_extrn.h"


#define pgVERS_ "V1.00"
#define pgTITL_ "Create links in a new HTML file"
#define pgCOPR_ "1998"


long    lines = 0 ;
FILE    *iFh, *oFh ;
UCHAR   iFile[FS_LEN], oFile[FS_LEN], work[10001], sURL[1025], sTitle[1025],
        sHTMpart1[FS_LEN], sHTMpart2[FS_LEN], cMarker='\x03', sMarker[]="\x03" ;


void    ShowHelp( void )
{
    logon(1);
    printf( "\nUsage:  %s database_in html_file_out\n\n"
            "Uses .HT1 and .HT2 with the same name as the output name.\n\n",
            get_global_program_name() );
    exit( 1 );
}


void    insert_file( STRING fname )
{
    FILE *fh ;

    if ( ( fh = fopen( fname, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", fname );
        ShowHelp();
    }

    while ( fgets( work, (sizeof(work)-1), fh ) )
    {
        fprintf( oFh, "%s", work );
    }

    fclose( fh );
}


void    main( int argc, char *argv[] )
{
    UCHAR       *p ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(1);

    if ( argc != 3 )
        ShowHelp();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        ShowHelp();
    }

    ST_CPY( sHTMpart1, oFile );                 // use output file name for part1/2 htm input
    p = strchr( oFile, '.' );                   // if no ext, use .HTM
    if ( p == NULL )
        ST_CAT( oFile, ".HTM" );

    p = strchr( sHTMpart1, '.' );               // strip ext if needed
    if ( p != NULL )
        *p = EOS ;

    ST_CPY( sHTMpart2, sHTMpart1 );             // fix names for 2 input files
    ST_CAT( sHTMpart1, ".HT1" );
    ST_CAT( sHTMpart2, ".HT2" );

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    insert_file( sHTMpart1 );

    while ( fgets( work, (sizeof(work)-1), iFh ) )
    {
        st_trim( work );
        if ( work[0] == cMarker )
            work[0] = EOS ;
        if ( strlen(work) )
        {
            sURL[0] = EOS ;
            SplitString( work, sMarker, sTitle, sURL );  // title & URL split
            st_trim( sTitle );
            st_trim( sURL );
            if ( strlen(sTitle) && strlen(sURL) )
            {
                fprintf( oFh, "<a href=\"%s\">%s</a><br>", sURL, sTitle );
                lines ++ ;
            }
        }

    }
    fprintf( oFh, "<br>There are %ld links on this page<br>"
                  "Last updated on %s<br>\n", lines, TodaysCDate() );
    insert_file( sHTMpart2 );
    fcloseall();

    printf( "Written %ld links to %s\n\n", lines, oFile );

    exit( 0 );
}
